#ifndef _BaseSerialPort_H
#define _BaseSerialPort_H

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <errno.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <stdlib.h>
#include <pthread.h>

#include "Common/include/WNNotificationCenter.h"

enum SerialPortType
{
	SP_Default = -1,
	NearReader,
	FarReader,
	RelayVoltage
};

class BaseSerialPort
{
public:
	BaseSerialPort();
	~BaseSerialPort();
	bool Start(int iPort, int iBaudRate, SerialPortType type);
	void Stop();
private:
	void StartRecver();
	static void * RecverWrapper(void * p);
	int FarRecverProcess();
	int NearRecverProcess();
	int RelayVoltageRecverProcess();
	
	bool OpenPort(int port);
	bool SetParams(int nSpeed, int nBits, char nEvent, int nStop);
	
	void SendCardNumber(int number, SerialPortType type);
	
	bool m_bRunning;
	SerialPortType m_type;
	int m_iFd;
	
	pthread_t m_thread_recver;
};

#endif //#ifndef _BaseSerialPort_H