/*utf8解析行 Don't remove or modify this first line!*/
#ifndef ACCALLBACK_H
#define ACCALLBACK_H
#include<new>
#include "stdlib.h"

    template<class ret_type, class arg_type>
    class function_base
    {
        public:
            function_base() {}
            virtual ~function_base(){}

            virtual ret_type operator() (arg_type) = 0;
    };

    template<class ret_type, class arg_type>
    class function_impl_normal: public function_base<ret_type, arg_type>
    {
        public:
            typedef ret_type (* NORM_PROC) (arg_type);
            explicit function_impl_normal(NORM_PROC proc): norm_proc_(proc) {}
            ret_type operator() (arg_type arg) { return norm_proc_(arg); }
        private:
            NORM_PROC norm_proc_;
    };

    template<class ret_type, class arg_type>
    class function
    {
        public:
            typedef ret_type (* NORM_PROC) (arg_type);

            explicit function(function_base<ret_type, arg_type>* fun): fun_(fun), ref_(new int(1)) {}

            function(NORM_PROC proc = 0): fun_(new function_impl_normal<ret_type, arg_type>(proc)), ref_(new int(1)) {}

            ret_type operator() (arg_type arg) { fun_->operator()(arg); }

            ~function()
            {
                Release();
            }

            void Release()
            {
                *ref_ -= 1;
                if (*ref_ == 0)
                {
                    delete ref_;
                    delete fun_;
                }
            }

            function(const function& fun)
            {
                fun_ = fun.fun_;
                ref_ = fun.ref_;
                *ref_ += 1;
            }

            void operator=(const function& fun)
            {
                Release();
                fun_ = fun.fun_;
                ref_ = fun.ref_;
                *ref_ += 1;
            }

        private:
            int* ref_;
            function_base<ret_type, arg_type>* fun_;
    };

    template<class CS, class ret_type, class arg_type>
    class function_impl: public function_base<ret_type, arg_type>
    {
        public:
            typedef ret_type (CS::* PROC)(arg_type);

            function_impl(CS* obj, PROC proc): obj_(obj), proc_(proc) {}

            ret_type operator() (arg_type arg) { return (obj_->*proc_)(arg); }

        private:
            CS* obj_;
            PROC proc_;
    };

    template<class CS, class ret_type, class arg_type>
    function<ret_type, arg_type> bind(ret_type (CS::* proc)(arg_type), CS* pc)
    {
        function_base<ret_type, arg_type>* pf = new function_impl<CS, ret_type, arg_type>(pc, proc);
        return function<ret_type, arg_type>(pf);
    }







    template<class CS, class ret_type>
    function<ret_type, void> bind(ret_type (CS::* proc)(), CS* pc)
    {
        function_base<ret_type, void>* pf = new function_impl<CS, ret_type, void>(pc, proc);
        return function<ret_type, void>(pf);
    }

	
struct _ACCallbackOpCodes
{
    unsigned char tag;  // CALL e8
    long* offset;  // offset (dest - src - 5, 5=sizeof(tag + offset))
    long* _this;   // a this pointer
    long* _func;   // pointer to real member function address
};

static void STDACJMPProc()
{
    asm
    (
       	"POP R7\n"
        "mov R6 , [R7 + 4]\n" // func
        "MOV R7 , [R7]\n"    // this  
        "BL  R6\n"
    );
}
static long* CalcJmpOffset(long* Src, long* Dest)
{
    return (long*)(Dest - (Src + 5));
}

template<typename _TPStdFunc, class _TClass, typename _TPMemberFunc>
class ACCallback
{
public:
    _TClass *m_pThis;
    _TPMemberFunc m_pFunc;

private:
    _TPStdFunc m_pStdFunc;

    void MakeCode()
    {
        if (m_pStdFunc) free(m_pStdFunc);
        m_pStdFunc = (_TPStdFunc)malloc(sizeof(_ACCallbackOpCodes));
        _ACCallbackOpCodes *p = (_ACCallbackOpCodes *)m_pStdFunc;
        p->_func = *(int* *)&m_pFunc;
        p->_this = (int*)m_pThis;
        p->tag = 0xE8;
        p->offset = CalcJmpOffset((int*)p, (int*)STDACJMPProc);
    }

public:
    ACCallback<_TPStdFunc, _TClass, _TPMemberFunc>()
    {
    }
    ACCallback<_TPStdFunc, _TClass, _TPMemberFunc>(_TClass* pThis,
        _TPMemberFunc pFunc
        )
    {
        m_pFunc = pFunc;
        m_pThis = pThis;
        m_pStdFunc = 0;
       // MakeCode();
    }
    void Assign(_TClass* pThis,
        _TPMemberFunc pFunc
        )
    {
        m_pFunc = pFunc;
        m_pThis = pThis;
        m_pStdFunc = 0;
        //MakeCode();
    }
    ~ACCallback<_TPStdFunc, _TClass, _TPMemberFunc>()
    {
        //::VirtualFree(m_pStdFunc, 0, MEM_RELEASE);
    }
    operator _TPStdFunc()
    {
        return m_pStdFunc;
    }
};

template <typename _TPStdFunc>
class ACCallbackEx
{
	template <typename _TClass, typename _TPMemberFunc>
	void MakeCode(_TClass* pThis, _TPMemberFunc pMenberFunc)
	{
		/*FreeCode();
		mpStdFunc = (_TPStdFunc)::VirtualAlloc(0, sizeof(_ACCallbackOpCodes), MEM_COMMIT, PAGE_EXECUTE_READWRITE);
		_ACCallbackOpCodes *p = (_ACCallbackOpCodes *)mpStdFunc;
		p->_func = *(int* *)&pMenberFunc;
		p->_this = (int*)pThis;
		p->tag = 0xE8;
		p->offset = CalcJmpOffset((int*)p, (int*)STDACJMPProc);*/
	}

public:
	ACCallbackEx()
	{
		mpStdFunc = 0;
	}

	~ACCallbackEx()
	{
	//	FreeCode();
	}

	operator _TPStdFunc()
	{
		return mpStdFunc;
	}
	
	_TPStdFunc StdFnPtr()
	{
		return mpStdFunc;
	}

	template <typename _TClass, typename _TPMemberFunc>
	void SetCallBackMemberFunc(_TClass* pThis, _TPMemberFunc pMenberFunc)
	{
		//MakeCode(pThis, pMenberFunc);
		//mpStdFunc = std::bind(pMenberFunc , pThis, _1 );
		//bind_base0<void>* tobj0  = bindfun(pThis,pMenberFunc);
		f = bind(pMenberFunc,pThis);
	}

	void operator()(int i=0){
		
	}
	void FreeCode()
	{
		if (mpStdFunc)
		{
			//::VirtualFree(mpStdFunc, 0, MEM_RELEASE);
			mpStdFunc = 0;
		}
	}

public:
	_TPStdFunc mpStdFunc;
	function<void ,int>  f;
	
};

#endif

