/*utf8解析行 Don't remove or modify this first line!*/
#ifndef WNBYTEBUFFER_H
#define WNBYTEBUFFER_H

#ifndef DEFAULT_BUFFER_SIZE
#define DEFAULT_BUFFER_SIZE 512
#endif

 

#include "WNCLoopList.h"
#include "WNObject.h"

class ByteBuffer
{
public:
	ByteBuffer(unsigned long dwBufferSize = DEFAULT_BUFFER_SIZE);
	ByteBuffer(void* pData, unsigned long dwSize);
	ByteBuffer(ByteBuffer& srcByteBuffer);
	virtual ~ByteBuffer();
	bool InitBuffer(unsigned long dwBufferSize = DEFAULT_BUFFER_SIZE, bool bReserveData = false, bool bReservePos = false);
	bool ReleaseBuffer();
	unsigned long SetValidString(unsigned long dwStrLen);
	unsigned long SetValidSize(unsigned long dwSize);
	//bool ReadFile(FILE* pFile, unsigned long dwReadSize = 0);
	bool ReadMemory(const void* pSrcData, unsigned long dwReadSize = 0);
	unsigned long OutputWithPos(void* pTarData, unsigned long dwOutputSize = 0, const unsigned long* pdwPos = NULL);
	unsigned long InputWithPos(const void* pSrcData, unsigned long dwInputSize = 0, const unsigned long* pdwPos = NULL );
	bool operator == (const ByteBuffer& srcData);
	bool operator == (const char* strSrc);
	inline bool operator != (const char* strSrc) { return (*this == strSrc)?false:true; }
	inline operator char* () { return (char*)m_pBuffer; }
	inline operator unsigned char* () { return (unsigned char*)m_pBuffer; }
	inline operator void* () { return (void*)m_pBuffer; }
	ByteBuffer& operator  = (const ByteBuffer& SrcByteBuffer);
	inline ByteBuffer& operator = (const char* strData);
	inline unsigned char& operator [] (unsigned long dwIndex) { return m_pBuffer[dwIndex]; }
	inline unsigned long BufferSize() { return m_dwBufferSize; } //返回实际使用的缓冲区大小，真实缓冲区要比实际缓冲区多2个字节。
	inline unsigned char* GetBuffer() { return m_pBuffer; }
	inline unsigned char* GetPosBuffer() { return m_pPos; }
	inline unsigned long GetPos() { return m_pPos - m_pBuffer; }
	inline bool SetPos(unsigned long dwIndex) { return (dwIndex && (dwIndex < m_dwBufferSize))?((m_pPos = m_pBuffer+ dwIndex)?true:false):false; }
	inline bool MovePos(long lOffset) { return SetPos(m_pPos + lOffset - m_pBuffer); }
	inline void MovePosBegin() { m_pPos = m_pBuffer; }
	inline char* GetString() { return (char*)m_pBuffer; }
	inline char* GetPosString() { return (char*)m_pPos; }
	inline unsigned long GetValidSize() { return m_dwValidSize; }
	//bool SaveFile(const char* strFilename, bool bUseValidSize = true);

public:
	unsigned long m_dwFlag;

protected:
	unsigned char* m_pBuffer;
	unsigned long m_dwBufferSize;
	unsigned long m_dwValidSize;
	unsigned char* m_pPos;
};

class WNByteBufferManager;

class WNByteBuffer : public ByteBuffer, public WNObject
{
public:
	WNByteBuffer(unsigned long dwBufferSize = DEFAULT_BUFFER_SIZE);

public:
	WNByteBufferManager* mpBufferManager;
};
#endif
