/*utf8解析行 Don't remove or modify this first line!*/
#ifndef WNBYTEBUFFERMANAGER_H
#define WNBYTEBUFFERMANAGER_H

#include "WNCreticalSection.h"
#include "WNCLoopList.h"
#include "WNByteBuffer.h"
#include "WNObject.h"

typedef WNCLoopList<WNByteBuffer> _WNByteBufferList;

class WNByteBufferList : public _WNByteBufferList
{
public:
	WNByteBufferList();
public:
	unsigned int muBufferSize;
};

#define DefMaxAllBufferSize 0x7FFFFFFF
#define DefMaxBufferCount 0x7FFFFFFF
#define DefMinBufferSize 1024
#define DefSetpBufferSize 1024
#define DefMaxBufferSize 1024*1024*10



class WNByteBufferManager : public WNCreticalSection, public WNObjectDelegate
{
public:
	//构造函数
	//uMinBufferSize表示缓冲区的最小大小
	//uStepBufferSize表示每级缓冲区增加的大小
	//uMaxBufferSize表示最大缓冲区大小
	WNByteBufferManager(unsigned uMinBufferSize = DefMinBufferSize, 
						unsigned int uSetpBufferSize = DefSetpBufferSize, 
						unsigned int uMaxBufferSize = DefMaxBufferSize);
	virtual ~WNByteBufferManager(void);
	//初始化缓冲区管理器
	void InitManager(unsigned int uMinBufferSize, unsigned int uStepBufferSize, unsigned int uMaxBufferSize);
	//释放缓冲区管理器
	void FreeManager();
	//初始化指定大小以及数量的未使用的缓冲区
	void InitBuffers(unsigned int uBufferSize, unsigned int uCount = 1);
	//获得指定大小的未使用的自由缓冲区
	//如果指定大小的缓冲区不存在则创建后返回
	WNByteBuffer* GetBuffer(unsigned int uBufferSize, bool mbThreadSafeBuffer = false);
	//释放缓冲区
	void FreeBuffer(WNByteBuffer* pBuffer);
    //设置自由缓冲区大小上限
	void SetMaxAllBufferSize(unsigned int uSize);
    //设置自由缓冲区数目上限
	void SetMaxBufferCount(unsigned int uCount);
	virtual bool OnWNObjectRetainCountIsZero(WNObject* pObject);
protected:
	//根据指定的大小获得适合的缓冲区列表
	WNByteBufferList* GetListByBufferSize(unsigned int uBufferSize);
public:
	WNByteBufferList* mpBufferList; //自由缓冲区列表数组，下标0-muListCount，元素0保存不在[muMinBufferSize, muMaxBufferSize]范围内的缓冲区
	unsigned int muListCount; //自由缓冲区列表数目
    unsigned int muMinBufferSize; //最小缓冲区大小
    unsigned int  muStepBufferSize; //每一级增加的缓冲区大小
    unsigned int  muMaxBufferSize; //最大缓冲区大小
    unsigned int muAllBufferSize; //所有缓冲区的大小
    unsigned int  muMaxAllBufferSize; //所有缓冲区的最大大小
    unsigned int muAllBufferCount; //所有缓冲区的数目
    unsigned int  muMaxAllBufferCount; //所有缓冲区的最大数目
};

#endif
