/*utf8解析行 Don't remove or modify this first line!*/
#ifndef WNINVOKER_H
#define WNINVOKER_H

#include "ACCallback.h"
#include "WNObject.h"
#include "WNReadWriteLocker.h"
#include "WNCLoopList.h"


#include <sys/time.h>       
extern long getCurrentTime();

class WNInvokeInfo : public WNObject
{
public:
	WNInvokeInfo();
	~WNInvokeInfo();
	virtual void InvokeMemberFunc() { return; }
	virtual void Reset();
public:
	BOOL mbInvoked;
	UINT muInvokeTime;
	void* mpReturnValue;
};

typedef void (*StdInvokeMemberFuncVoid)();
template <typename _TClass, typename _TPMemberFunc>
class InvokeMemberFuncVoidInfo : public WNInvokeInfo
{
public:
	virtual void InvokeMemberFunc()
	{
		mCallBack.mpStdFunc();
		mbInvoked = TRUE;
	}

	virtual void Reset()
	{
		mCallBack.FreeCode();
		WNInvokeInfo::Reset();
	}
public:
	ACCallbackEx<StdInvokeMemberFuncVoid> mCallBack;
};

typedef void (*StdInvokeMemberFuncVoidWNObject)(WNObject*);
template <typename _TClass, typename _TPMemberFunc>
class InvokeMemberFuncVoidWNObjectInfo : public WNInvokeInfo
{
public:
	InvokeMemberFuncVoidWNObjectInfo()
	{
		mpParam = NULL;
	}
	virtual void InvokeMemberFunc()
	{
		mCallBack.mpStdFunc(mpParam);
		mbInvoked = TRUE;
	}

	virtual void Reset()
	{
		doRelease(mpParam);
		WNInvokeInfo::Reset();
	}
public:
	ACCallbackEx<StdInvokeMemberFuncVoidWNObject> mCallBack;
	WNObject* mpParam;
};



class WNInvoker
{
public:
	virtual ~WNInvoker();

	//执行类对象的成员函数
	//支持的成员函数形式为void Class::MemberFunc();
	//pObject是要执行成员函数的对象
	//		 请注意保证在函数被执行前pObject不要被销毁
	//pMemberFunc是成员函数指针
	//pParam是要执行的成员函数参数
	//uAfterDelay表示执行的延迟，为0表示在执行线程的下一个循环中执行
	//返回值为执行信息
	template <typename _TClass, typename _TPMemberFunc>
	WNInvokeInfo* InvokeMemberFuncVoid(_TClass* pObject, _TPMemberFunc pMemberFunc, UINT uAfterDelay = 0)
	{
		InvokeMemberFuncVoidInfo<_TClass, _TPMemberFunc>* pInvokeInfo = _WNSafeAlloc<InvokeMemberFuncVoidInfo<_TClass, _TPMemberFunc> >();
		pInvokeInfo->Retain(); 
		pInvokeInfo->mCallBack.SetCallBackMemberFunc(pObject, pMemberFunc);
		pInvokeInfo->muInvokeTime = getCurrentTime() + uAfterDelay;
		AddInvokeInfo(pInvokeInfo);
		return pInvokeInfo;
	}


	//执行类对象的成员函数
	//支持的成员函数形式为void Class::MemberFunc(WNObject*);
	//pObject是要执行成员函数的对象
	//		 请注意保证在函数被执行前pObject不要被销毁
	//pMemberFunc是成员函数指针
	//pParam是要执行的成员函数参数
	//uAfterDelay表示执行的延迟，为0表示在执行线程的下一个循环中执行
	////返回值为执行信息
	template <typename _TClass, typename _TPMemberFunc>
	WNInvokeInfo* InvokeMemberFuncVoidWNObject(_TClass* pObject, _TPMemberFunc pMemberFunc, WNObject* pParam = NULL, UINT uAfterDelay = 0)
	{
		InvokeMemberFuncVoidWNObjectInfo<_TClass, _TPMemberFunc>* pInvokeInfo = _WNSafeAlloc<InvokeMemberFuncVoidWNObjectInfo<_TClass, _TPMemberFunc> >();
		pInvokeInfo->Retain();
		pInvokeInfo->mCallBack.SetCallBackMemberFunc(pObject, pMemberFunc);
		if (pParam)
		{
			pInvokeInfo->mpParam = pParam->Retain();
		}
		pInvokeInfo->muInvokeTime = getCurrentTime() + uAfterDelay;
		AddInvokeInfo(pInvokeInfo);
		return pInvokeInfo;
	}
	virtual void AddInvokeInfo(WNInvokeInfo* pInvokeInfo);
	//检查执行队列中是否有需要执行的函数
	//如果有则执行所有的函数
	//返回是否有执行函数
	virtual BOOL DoCheckAndInvoke();
	//检查执行队列中是否有需要执行的函数
	//如果队列中有需要执行的函数则返回TRUE，否则返回FALSE
	virtual BOOL DoCheckInvoke();
	//调用执行队列中的函数
	//只做一次调用
	//如果执行了函数返回TRUE，否则返回FALSE
	virtual BOOL DoInvoke();
public:
	WNCLoopList<WNInvokeInfo*> mInvokeList;
	WNReadWriteLocker mInvokeLocker;
};

#endif