/*utf8解析行 Don't remove or modify this first line!*/
#ifndef WNSOCKETSELECTOBSERVER_H
#define WNSOCKETSELECTOBSERVER_H

#include "WNSocketObserver.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/select.h>
#include <pthread.h>

class WNSocketSelectObserver : IWNSocketObserver
{
public: 
	WNSocketSelectObserver();
	~WNSocketSelectObserver();
	virtual bool AddSocket(WNSocketObserverTarget* socketInfo);
	virtual bool RemoveSocket(WNSocketObserverTarget* socketInfo);
	virtual bool StartServer();
	virtual bool StopServer();
	virtual const char* GetServerName();
	virtual bool IsWorking();
protected:
	static void*  SelectThreadProc(void* lpParameter);
	virtual bool InternalStartServer();
	virtual bool InternalStopServer();
	virtual bool InternalAddSocket(WNSocketObserverTarget* socketInfo);
	virtual bool InternalRemoveSocket(WNSocketObserverTarget* socketInfo);
	virtual long InternalSelectThreadProc();
	virtual void CreateLocker();
	virtual void DestroyLocker();
	virtual bool TryLock();
	virtual bool Lock();
	virtual bool Unlock();
protected:
	pthread_t mdwThreadId; //select线程id
	int mThreadHandle; //select线程handle
	bool mbIsWorking; //表示工作线程正在工作
	bool mbExitThread; //是否需要退出线程
	WNSocketObserverTargetList mTargetList; //目标socket列表
	WNCreticalSection* mpOperateLocker; //操作锁
};


#endif
