/*utf8解析行 Don't remove or modify this first line!*/
#include "IniFileManager.h"
#include<stdlib.h>
#include <string>

using namespace std;

static const u_char charmap[] = {
	'\000', '\001', '\002', '\003', '\004', '\005', '\006', '\007',
	'\010', '\011', '\012', '\013', '\014', '\015', '\016', '\017',
	'\020', '\021', '\022', '\023', '\024', '\025', '\026', '\027',
	'\030', '\031', '\032', '\033', '\034', '\035', '\036', '\037',
	'\040', '\041', '\042', '\043', '\044', '\045', '\046', '\047',
	'\050', '\051', '\052', '\053', '\054', '\055', '\056', '\057',
	'\060', '\061', '\062', '\063', '\064', '\065', '\066', '\067',
	'\070', '\071', '\072', '\073', '\074', '\075', '\076', '\077',
	'\100', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
	'\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
	'\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
	'\170', '\171', '\172', '\133', '\134', '\135', '\136', '\137',
	'\140', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
	'\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
	'\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
	'\170', '\171', '\172', '\173', '\174', '\175', '\176', '\177',
	'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
	'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
	'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
	'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
	'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
	'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
	'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
	'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
	'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
	'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
	'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
	'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
	'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
	'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
	'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
	'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

int strcasecmp(const char *s1, const char* s2)
{
	register const u_char *cm = charmap,
		*us1 = (const u_char *)s1,
		*us2 = (const u_char *)s2;

	while (cm[*us1] == cm[*us2++])
		if (*us1++ == '\0')
			return (0);
	return (cm[*us1] - cm[*--us2]);
}

bool NoCase::compare (const string& x, const string& y)
{
	/*string::const_iterator p = x.begin();
	string::const_iterator q = y.begin();
	while (p != x.end() && q != y.end() && toupper(*p) == toupper(*q))
	{
	++p;
	++q;
	}
	if (p == x.end())
	{
	return (q == y.end());
	}
	if (q == y.end())
	{
	return false;
	}
	return (toupper(*p) < toupper(*q));*/
	int ret = strcasecmp(x.c_str(),y.c_str());

	return (0 == ret) ? true : false;
} 


IniKeyInfo::IniKeyInfo()
:m_strKeyName((""))
,m_strKeyValue((""))
,m_strKeyTrimLeft((""))
,m_strKeyTrimRight((""))
,m_strValueTrimLeft((""))
,m_strValueTrimRight((""))
,m_pSection(NULL)
{

}

void IniKeyInfo::SetKeyName(const char* lpKeyName, bool bDoTrim /* = true */)
{
	if (!lpKeyName)
	{
		m_strKeyName = ("");
	}
	else
	{
		m_strKeyName = lpKeyName;
	}

	if (bDoTrim)
	{
		//得到key的有效以及无效字符串
		TrimAndGetTrimValue(m_strKeyName, m_strKeyTrimLeft, m_strKeyTrimRight);
	}
}

void IniKeyInfo::SetKeyValue(const char* lpKeyValue, bool bDoTrim /* = true */)
{
	if (!lpKeyValue)
	{
		m_strKeyValue = ("");
	}
	else
	{
		m_strKeyValue = lpKeyValue;
	}
	if (bDoTrim)
	{
		//得到value的有效以及无效字符串
		TrimAndGetTrimValue(m_strKeyValue, m_strValueTrimLeft, m_strValueTrimRight);
	}
}

void IniKeyInfo::SetMultiLineString( const char* lpKeyValue )
{
	m_strKeyValue = lpKeyValue;
	//m_strKeyValue.replace(("\r\n"), ("<br>"));
	string searchString = "\r";
	string replaceString = "<\r>";
	string::size_type pos = 0;
	
	while ( (pos = m_strKeyValue.find(searchString, pos)) != string::npos ) {
		m_strKeyValue.replace( pos, searchString.size(), replaceString );
		pos++;
	}
	
	searchString = "\n";
	replaceString = "<\n>";
	pos = 0;
	while ( (pos = m_strKeyValue.find(searchString, pos)) != string::npos ) {
		m_strKeyValue.replace( pos, searchString.size(), replaceString );
		pos++;

	}

}

long IniKeyInfo::ToLong(long lDefault /* = 0 */)
{
    if (m_strKeyValue == (""))
    {
        return lDefault;
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5),(("[Val]"))))
    {
        return atol(m_strKeyValue.substr(5).c_str());
    }
    else if(NoCase::compare(m_strKeyValue.substr(0,5).c_str(),"[Sec]"))
    {
        int iPos = m_strKeyValue.find((","));
        string strSec = m_strKeyValue.substr(5, iPos - 5);
        string strKey = m_strKeyValue.substr(iPos + 1);
        return m_pSection->GetManager()->ToLong(strSec.c_str(), strKey.c_str(), lDefault);
    }
    return atol(m_strKeyValue.c_str());

}

unsigned long IniKeyInfo::ToULong(unsigned long ulDefault /* = 0 */)
{
    if (m_strKeyValue == (""))
    {
        return ulDefault;
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5).c_str(),"[Val]"))
    {
        return strtoul(m_strKeyValue.substr(5).c_str(), NULL, 10);
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5).c_str(),"[Sec]"))
    {
        int iPos = m_strKeyValue.find((","));
        string strSec = m_strKeyValue.substr(5, iPos - 5);
        string strKey = m_strKeyValue.substr(iPos + 1);
        return m_pSection->GetManager()->ToULong(strSec.c_str(), strKey.c_str(), ulDefault);
    }
    return strtoul(m_strKeyValue.c_str(), NULL, 10);
    
	
  
    return 0;
}

long IniKeyInfo::ToHex(long lDefault /* = 0 */)
{
    if (m_strKeyValue == (""))
    {
        return lDefault;
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Val]"))
    {
        return strtol(m_strKeyValue.substr(5).c_str(), NULL, 16);
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Sec]"))
    {
        int iPos = m_strKeyValue.find((","));
        string strSec = m_strKeyValue.substr(5, iPos - 5);
        string strKey = m_strKeyValue.substr(iPos + 1);
        return m_pSection->GetManager()->ToHex(strSec.c_str(), strKey.c_str(), lDefault);
    }


   
   
   return strtol(m_strKeyValue.c_str(),0,16);
  
}

unsigned long IniKeyInfo::ToUHex(unsigned long ulDefault /* = 0 */)
{
   if (m_strKeyValue == (""))
    {
        return ulDefault;
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Val]"))
    {
       return strtoul(m_strKeyValue.substr(5).c_str(), NULL, 16);
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Sec]"))
    {
        int iPos = m_strKeyValue.find((","));
        string strSec = m_strKeyValue.substr(5, iPos - 5);
        string strKey = m_strKeyValue.substr(iPos + 1);
        return m_pSection->GetManager()->ToUHex(strSec.c_str(), strKey.c_str(), ulDefault);
    }
    return strtoul(m_strKeyValue.c_str(), NULL, 16);

}

double IniKeyInfo::ToDouble(double dblDefault /* = 0.0 */)
{
	if (m_strKeyValue == (""))
	{
		return dblDefault;
	}
	else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Val]"))
	{
		return atof(m_strKeyValue.substr(5).c_str());
	}
	else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Sec]"))
	{
		int iPos = m_strKeyValue.find((","));
		string strSec = m_strKeyValue.substr(5, iPos - 5);
		string strKey = m_strKeyValue.substr(iPos + 1);
		return m_pSection->GetManager()->ToDouble(strSec.c_str(), strKey.c_str(), dblDefault);
	}
	return atof(m_strKeyValue.c_str());
}


string IniKeyInfo::ToString(const char* lpDefault /* = ("") */)
{
   if (m_strKeyValue == (""))
    {
        return lpDefault;
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Val]"))
    {
        return m_strKeyValue.substr(5);
    }
    else if (NoCase::compare(m_strKeyValue.substr(0,5),"[Sec]"))
    {
        int iPos = m_strKeyValue.find((","));
        string strSec = m_strKeyValue.substr(5, iPos - 5);
        string strKey = m_strKeyValue.substr(iPos + 1);
        return m_pSection->GetManager()->ToString(strSec.c_str(), strKey.c_str(), lpDefault );
    }
    return m_strKeyValue;
}


string IniKeyInfo::ToMultiLineString( const char* lpDefault /*= ("")*/ )
{
	string strRet = ToString(lpDefault);
	/*strRet.Replace(("<br>"), ("\r\n"));*/
	string searchString = "<\r>";
	string replaceString = "\r";
	string::size_type pos = 0;
	
	while ( (pos = strRet.find(searchString, pos)) != string::npos ) {
		strRet.replace( pos, searchString.size(), replaceString );
		pos++;
	}

	searchString = "<\n>";
	replaceString = "\n";
	pos = 0;
	while ( (pos = strRet.find(searchString, pos)) != string::npos ) {
		strRet.replace( pos, searchString.size(), replaceString );
		pos++;
	}

	return strRet;

}

#define KEY_NAME_EX (m_strKeyTrimLeft + m_strKeyName + m_strKeyTrimRight)
#define KEY_VALUE_EX (m_strValueTrimLeft + m_strKeyValue + m_strValueTrimRight)

string IniKeyInfo::GetText() 
{
	if (m_strKeyName == (""))
	{
		return KEY_VALUE_EX;
	}
	else
	{
		return KEY_NAME_EX + ('=') + KEY_VALUE_EX;
	}
}

string IniKeyInfo::GetTextEx()
{ 
	if (m_strKeyName == (""))
	{
		if (m_strKeyValue == (""))
		{
			return KEY_VALUE_EX;
		}
		else
		{
			return SplitStrP() + KEY_VALUE_EX;
		}
	}
	else
	{
		return SplitStrP() + KEY_NAME_EX + ('=') + KEY_VALUE_EX;
	}
}


void IniKeyInfo::TrimAndGetTrimValue( string& strSrc, string& strTrimLeft, string& strTrimRight )
{
	int iLen = strSrc.length();
	//得到左边的无效字符串
	strTrimLeft = ("");
	for (int i = 0; i < iLen; i++)
	{
		if ((strSrc[i] != (' ')) && (strSrc[i] != ('\t')))
		{
			if (i)
			{
				strTrimLeft = strSrc.substr(0,i);
			}
			break;
		}
	}
	//得到右边的无效字符串
	strTrimRight= ("");
	for (int i = 0; i < iLen; i++)
	{
		if ((strSrc[iLen - i - 1] != (' ')) && (strSrc[iLen - i - 1] != ('\t')))
		{
			if (i)
			{
				strTrimRight = strSrc.substr(iLen - i);
			}
			break;
		}
	}
	//修改strSrc为有效字符串
	int iStart = strTrimLeft.length();
	int iEnd = iLen - strTrimRight.length();
	int iCount = iEnd - iStart;
	if (iCount != iLen)
	{
		strSrc = strSrc.substr(iStart, iCount);
	}
}

inline const char* IniKeyInfo::SplitStrP() 
{ 
	return m_pSection->GetManager()->SplitStrP(); 
}

inline string& IniKeyInfo::SplitStrR() 
{ 
	return m_pSection->GetManager()->SplitStrR(); 
}

IniSectionInfo::IniSectionInfo()
:m_strSectionName((""))
,m_pManager(NULL)
{

}

PIniKeyInfo IniSectionInfo::AddKey(const char* lpKeyName, const char* lpKeyValue, bool bReplace /* = true */)
{
    PIniKeyInfo pNode = AddKey(lpKeyName);
    if (bReplace)
    {
		pNode->SetKeyValue(lpKeyValue);
    }
    return pNode;
}


PIniKeyInfo IniSectionInfo::AddKeyEx(const char* lpKeyName)
{
    PNode pRet = new Node;
	pRet->data.SetKeyName(lpKeyName);
    pRet->data.SetSection(this);
    AppendNode(pRet);
    return &(pRet->data);
}

PIniKeyInfo IniSectionInfo::AddKeyEx(const char* lpKeyName, const char* lpKeyValue)
{
    PNode pRet = new Node;
	pRet->data.SetKeyName(lpKeyName);
	pRet->data.SetKeyValue(lpKeyValue);
    pRet->data.SetSection(this);
    AppendNode(pRet);
    return &(pRet->data);
}



PIniKeyInfo IniSectionInfo::ParseData(const char* lpData, bool bReplace /* = true */)
{
    string strData(lpData);
    string strSplit(("="));
	if (strData == "")
	{
		AddKeyEx((""), lpData);
	}
	else if (strData[0] == (':'))
    {
        return AddKeyEx((""), lpData);
    }
    else
    {
        int iPos = strData.find(strSplit);
        string strKeyName = strData.substr(0, iPos);
        string strKeyValue = strData.substr(iPos + strSplit.length());
        if (strKeyName == (""))
        {
            return AddKeyEx((""), lpData);
        }
        else
        {
            return AddKey(strKeyName.c_str(), strKeyValue.c_str(), bReplace);
        }
    }
    return NULL;
}

PIniKeyInfo IniSectionInfo::ParseDataEx(const char* lpData)
{
    string strData(lpData);
    string strSplit(("="));
	if (strData == "")
	{
		AddKeyEx((""), lpData);
	}
    else if (strData[0] == (':'))
    {
        return AddKeyEx((""), lpData);
    }
    else
    {
        int iPos = strData.find(strSplit);
        if (iPos == -1)
        {
            return AddKeyEx((""), lpData);
        }
        else
        {
            string strKeyName = strData.substr(0, iPos);
            string strKeyValue = strData.substr(iPos + strSplit.length());
            return AddKeyEx(strKeyName.c_str(), strKeyValue.c_str());
        }
    }
    return 0;
}



PIniKeyInfo IniSectionInfo::GetKey(const char* lpKeyName, bool bAdd /* = false */)
{
    for (MoveBegin(); Current() != Head(); MoveNext())
    {
        if (NoCase::compare(Current()->data.KeyName(),lpKeyName))
        {
            return &(Current()->data);
        }
    }
    if (bAdd)
    {
        return AddKeyEx(lpKeyName);
    }
    else
    {
        return NULL;
    }
    return 0;
}

long IniSectionInfo::ToLong(const char* lpKeyName, long lDefault /* = 0 */)
{
    PIniKeyInfo pKeyInfo = GetKey(lpKeyName);
    if (pKeyInfo)
    {
        return pKeyInfo->ToLong(lDefault);
    }
    else
    {
        return lDefault;
    }
 
}

unsigned long IniSectionInfo::ToULong(const char* lpKeyName, unsigned long ulDefault /* = 0 */)
{
    PIniKeyInfo pKeyInfo = GetKey(lpKeyName);
    if (pKeyInfo)
    {
        return pKeyInfo->ToULong(ulDefault);
    }
    else
    {
        return ulDefault;
    }
}

long IniSectionInfo::ToHex(const char* lpKeyName, long lDefault /* = 0 */)
{
    PIniKeyInfo pKeyInfo = GetKey(lpKeyName);
    if (pKeyInfo)
    {
        return pKeyInfo->ToHex(lDefault);
    }
    else
    {
        return lDefault;
    }

}

unsigned long IniSectionInfo::ToUHex(const char* lpKeyName, unsigned long ulDefault /* = 0 */)
{
   PIniKeyInfo pKeyInfo = GetKey(lpKeyName);
    if (pKeyInfo)
    {
        return pKeyInfo->ToUHex(ulDefault);
    }
    else
    {
        return ulDefault;
    }
}

double IniSectionInfo::ToDouble(const char* lpKeyName, double dblDefault /* = 0.0 */)
{
	PIniKeyInfo pKeyInfo = GetKey(lpKeyName);
	if (pKeyInfo)
	{
		return pKeyInfo->ToDouble(dblDefault);
	}
	else
	{
		return dblDefault;
	}
}


string IniSectionInfo::ToString(const char* lpKeyName, const char* lpDefault /* = ("") */)
{
    PIniKeyInfo pKeyInfo = GetKey(lpKeyName);
    if (pKeyInfo)
    {
        return pKeyInfo->ToString(lpDefault);
    }
    else
    {
        return lpDefault;
    }
}


string IniSectionInfo::ToMultiLineString( const char* lpKeyName, const char* lpDefault /*= ("")*/ )
{
	PIniKeyInfo pKeyInfo = GetKey(lpKeyName);
	if (pKeyInfo)
	{
		return pKeyInfo->ToMultiLineString(lpDefault);
	}
	else
	{
		return lpDefault;
	}
}


string IniSectionInfo::GetText()
{
    string strRet((""));
    if (m_strSectionName != (""))
    {
        strRet = ("[") + m_strSectionName + ("]");
        for (MoveBegin(); Current() != Head(); MoveNext())
        {
            strRet += SplitStrP();
            strRet += Current()->data.GetText();
        }
    }
    else
    {
        for (MoveBegin(); Current() != Head(); MoveNext())
        {
            strRet += Current()->data.GetText();
            if (Current() != End())
            {
                strRet += SplitStrP();
            }
        }
    }
	return strRet;
}

string IniSectionInfo::GetTextEx()
{
    string strRet((""));
    if (m_strSectionName != (""))
    {
        strRet = ("[") + m_strSectionName + ("]");
    }
    else
    {
        return strRet;
    }
    for (MoveBegin(); Current() != Head(); MoveNext())
    {
        strRet += Current()->data.GetTextEx();
    }
    return strRet;
}


void IniSectionInfo::JoinTo(IniSectionInfo& tarSection)
{
    for (MoveBegin(); Current() != Head(); MoveNext())
    {
        PIniKeyInfo pTarKey = tarSection.GetKey(Current()->data.KeyName().c_str());
        if (!pTarKey)
        {
            tarSection.AddKeyEx(Current()->data.KeyName().c_str(), Current()->data.KeyValue().c_str());
        }
    }
}

inline const char* IniSectionInfo::SplitStrP()
{ 
	return m_pManager->SplitStrP();
}

inline string& IniSectionInfo::SplitStrR()
{ 
	return m_pManager->SplitStrR();
}


IniFileManager::IniFileManager(bool bAutoSave /* = false */)
:mstrIniFileName((""))
,mstrLineSplit(INI_CRLF)
,m_bUnicode(false)
,m_bAutoSave(bAutoSave)
{
	Head()->data.SetManager(this);
}


IniFileManager::~IniFileManager()
{
	if (DidStateChanged())
	{
		SaveFile();
	}
}

PIniSectionInfo IniFileManager::AddSectionEx(const char* lpSectionName)
{
    PNode pRet = new Node;
    pRet->data.SectionName() = lpSectionName;
    pRet->data.SetManager(this);
    AppendNode(pRet);
    return &(pRet->data);
}


PIniSectionInfo IniFileManager::GetSection(const char* lpSectionName, bool bAdd /* = false */)
{
    string strSecName(lpSectionName);
    if (strSecName == (""))
    { 
        return &(Head()->data);  
    }
    if (ListCount())
    {
        for (MoveBegin(); Current() != Head(); MoveNext())
        {
            if (NoCase::compare(Current()->data.SectionName().c_str(),(lpSectionName)))
            {
                return &(Current()->data);
            }
        }
    }
    if (bAdd)
    {
        return AddSectionEx(lpSectionName);
    }
    else
    {
        return NULL;
    }

}

bool IniFileManager::ParseSectionName(const char* lpData, string& strSectionName)
{
    string strData(lpData);
   if (strData.substr(0,1) == ("[") && strData.substr(strData.length() - 1) == ("]") && strData.length() > 2 )
    {
        strSectionName = strData.substr(1, strData.length() - 2);
        return true;
    }
    else
    {
        strSectionName = strData;
        return false;
    }
    return true;
}


PIniSectionInfo IniFileManager::ParseLine(const char* lpData, bool* pbReplace /* = NULL */)
{
    string strSectionName((""));
    //if (strSectionName == lpData)
    //{
    //    return NULL;
    //}
    if (ParseSectionName(lpData, strSectionName))
    {
        if (!pbReplace)
        {
            return AddSectionEx(strSectionName.c_str());
        }
        else
        {
            return AddSection(strSectionName.c_str(), *pbReplace);
        }
    }
    else
    {
        if (!pbReplace)
        {
            PIniSectionInfo pRet = &(MoveEnd()->data);
            pRet->ParseDataEx(lpData);
            return pRet;
        }
        else
        {
            PIniSectionInfo pRet = &(MoveEnd()->data);
            pRet->ParseData(lpData, *pbReplace);
            return pRet;
        }
    }
    return NULL;
}

bool IniFileManager::ParseData(const char* lpData, bool* pbReplace /* = NULL */)
{
    if (!pbReplace)
    {
        Head()->data.ClearList();
        ClearList();
    }
    string strData(lpData);
    string strSplit((""));
    string strLine((""));
    int iPos = 0;
    int iLastPos = 0;
	//检查行分隔符
	while (true)
	{
        if (string::npos != strData.find("\r\n"))
		{
			//找到"\r\n"作为换行行分隔符
			strSplit = "\r\n";
			break;
		}
        if (string::npos != strData.find("\n"))
		{
			//找到"\n"(0x0A)作为换行分隔符
			strSplit = "\n";
			break;
		}
        if (string::npos != strData.find("\r"))
		{
			//找到"\r"(0x0D)作为换行分隔符
			strSplit = "\r";
			break;
		}
		//使用默认换行分隔符
		strSplit = INI_CRLF;
		break;
	}

    while (true)
    {
        iLastPos = strData.find(strSplit, iPos);
        if (iLastPos == -1)
        {
            strLine = strData.substr(iPos);
            ParseLine(strLine.c_str());
			if (m_bAutoSave)
			{
				SaveState();
			}
			//保存换行分隔符
			mstrLineSplit = strSplit;
            return true;
        }
        else
        {
            strLine = strData.substr(iPos, iLastPos - iPos);
            ParseLine(strLine.c_str());
            iPos += strLine.length();
            iPos += strSplit.length();
        }
    }
	//保存换行分隔符
	mstrLineSplit = strSplit;
    return true;
}

bool IniFileManager::ParseFile(const char* lpFileName, bool* pbReplace /* = NULL */)
{
   int filesize = 0;


	FILE *fp;  
	fp = fopen(lpFileName, "rb");	
	if(fp == NULL)
	{
		if (m_bAutoSave)
		{
			mstrIniFileName = lpFileName;
			SaveState();
		}
		return false;  
	}
	fseek(fp, 0L, SEEK_END);  
	filesize = ftell(fp);  
	//fclose(fp);  

    if (filesize == 0)
    {

        return false;
    }
 
	
    char* pbData = new  char[filesize + 1];
    memset(pbData, 0x00,filesize + 1);
 

	fseek(fp, 0L, 0);  
	fread(pbData,filesize,1,fp);
	
	fclose(fp);
	bool bRet = false;
	if((pbData[0] == 0xEE) && (pbData[1] == 0xBB) && (pbData[2] == 0xBF)){
		m_bUnicode = true;
		bRet = ParseData(reinterpret_cast<const char*>(pbData + 3), pbReplace);
	}else{
		bRet = ParseData(reinterpret_cast<const char*>(pbData), pbReplace);
	}
	
    /*if (!bRet)
    {
		if (m_bAutoSave)
		{
			mstrIniFileName = lpFileName;
			SaveState();
		}
        delete[] pbData;
        return false;
    }
    else*/
    {
        //mstrIniFileName = lpFileName;

       /* if ((pbData[0] == 0xFF) && (pbData[1] == 0xFE))
        	{
           	 bRet = ParseData(reinterpret_cast<const char*>(pbData + 2), pbReplace);
            	m_bUnicode = true;
        	}
        	else
        	{
            m_bUnicode = false;
            int iSize = ::MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, reinterpret_cast<LPCSTR>(pbData), -1, NULL, 0);
            if (!iSize)
            {
                bRet = ParseData(reinterpret_cast<const char*>(pbData), pbReplace);
            }
            else
            {
                string strData((""));
                char* lpData = strData.GetBuffer((iSize + 1) * sizeof(TCHAR));
                memset(lpData, (iSize + 1) * sizeof(TCHAR));
                ::MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, reinterpret_cast<LPCSTR>(pbData), -1, lpData, (iSize + 1) * sizeof(TCHAR));
                strData.ReleaseBuffer();
                bRet = ParseData(strData, pbReplace);
            }
        	}*/
        
        mstrIniFileName = lpFileName;
        delete[] pbData;
        return bRet;
    }
   return true;
}

bool IniFileManager::SaveFile(const char* lpFileName /* = NULL */, bool* pbUnicode /* = NULL */)
{
    string strFileName = lpFileName?lpFileName:mstrIniFileName;
    if (strFileName == (""))
    {
        return false;    
    }
    string strText = ("");
    bool bUnicode = m_bUnicode;
    if (!pbUnicode)
    {
        bUnicode = m_bUnicode;
    }
    else
    {
        bUnicode = *pbUnicode;
    }   
    if (bUnicode)
    {
        strText = ("\xEF\xBB\xBF");
    }
    strText += GetText();
	FILE *fp = NULL;  
	fp = fopen(strFileName.c_str(), "wb+");	
	if(fp == NULL)	
		return false;  
	fwrite(strText.c_str(),strText.length(),1,fp);
	fclose(fp);
	//save tor file wlf
    /*if (bUnicode)
    {
        int iLen = strText.GetLength();
        char* lpData = strText.GetBuffer((iLen + 1) * sizeof(TCHAR));
        bool bRet = ::SaveFile(strFileName, lpData, iLen * sizeof(TCHAR));
        strText.ReleaseBuffer();
        return bRet;
    }
    else
    {
        int iLen = strText.GetLength();
        int iBufLen = (iLen + 1) * sizeof(TCHAR);
        char* lpData = strText.GetBuffer(iBufLen);
        unsigned char* pData = new unsigned char[iBufLen];
        memset(pData, iBufLen);
        int iWrite = ::WideCharToMultiByte(CP_ACP, 0, lpData, -1, reinterpret_cast<LPSTR>(pData), iBufLen, NULL, NULL);
        bool bRet = ::SaveFile(strFileName, pData, iWrite - 1);
        strText.ReleaseBuffer();
        delete[] pData;
        return bRet;
    }
    */
    return true;
}


bool IniFileManager::SaveFileEx(const char* lpFileName /* = NULL */, bool* pbUnicode /* = NULL */)
{
    string strFileName = lpFileName?lpFileName:mstrIniFileName;
	strFileName = lpFileName;
    if (strFileName == (""))
    {
        return false;    
    }
    string strText = ("");
    bool bUnicode = m_bUnicode;
    if (!pbUnicode)
    {
        bUnicode = m_bUnicode;
    }
    else
    {
        bUnicode = *pbUnicode;
    }
    if (bUnicode)
    {
        strText = ("\xEF\xBB\xBF");
    }
    strText += GetTextEx();
	FILE *fp = NULL;  
	fp = fopen(strFileName.c_str(), "wb+");	
	if(fp == NULL){
		perror("t:");
		return false;
	}
	fwrite(strText.c_str(),strText.length(),1,fp);
	fclose(fp);
    bool bRet = true;
    return bRet;

}

long IniFileManager::ToLong(const char* lpSectionName, const char* lpKeyName, long lDefault /* = 0 */)
{
    PIniSectionInfo pSectionInfo = GetSection(lpSectionName);
    if (!pSectionInfo)
    {
        return lDefault;
    }
    if (pSectionInfo == &(Head()->data))
    {
        return lDefault;
    }
    else
    {
        return pSectionInfo->ToLong(lpKeyName, lDefault);
    }

}

unsigned long IniFileManager::ToULong(const char* lpSectionName, const char* lpKeyName, unsigned long ulDefault /* = 0 */)
{
    PIniSectionInfo pSectionInfo = GetSection(lpSectionName);
    if (!pSectionInfo)
    {
        return ulDefault;
    }
    if (pSectionInfo == &(Head()->data))
    {
        return ulDefault;
    }
    else
    {
        return pSectionInfo->ToULong(lpKeyName, ulDefault);
    }
}

long IniFileManager::ToHex(const char* lpSectionName, const char* lpKeyName, long lDefault /* = 0 */)
{
    PIniSectionInfo pSectionInfo = GetSection(lpSectionName);
    if (!pSectionInfo)
    {
        return lDefault;
    }
    if (pSectionInfo == &(Head()->data))
    {
        return lDefault;
    }
    else
    {
        return pSectionInfo->ToHex(lpKeyName, lDefault);
    }
}

unsigned long IniFileManager::ToUHex(const char* lpSectionName, const char* lpKeyName, unsigned long ulDefault /* = 0 */)
{
    PIniSectionInfo pSectionInfo = GetSection(lpSectionName);
    if (!pSectionInfo)
    {
        return ulDefault;
    }
    if (pSectionInfo == &(Head()->data))
    {
        return ulDefault;
    }
    else
    {
        return pSectionInfo->ToUHex(lpKeyName, ulDefault);
    }

}


double IniFileManager::ToDouble( const char* lpSectionName, const char* lpKeyName, double dblDefault /*= 0.0*/ )
{
	PIniSectionInfo pSectionInfo = GetSection(lpSectionName);
	if (!pSectionInfo)
	{
		return dblDefault;
	}
	if (pSectionInfo == &(Head()->data))
	{
		return dblDefault;
	}
	else
	{
		return pSectionInfo->ToDouble(lpKeyName, dblDefault);
	}
}


string IniFileManager::ToString(const char* lpSectionName, const char* lpKeyName, const char* lpDefault /* = ("") */)
{
    PIniSectionInfo pSectionInfo = GetSection(lpSectionName);
    if (!pSectionInfo)
    {
        return lpDefault;
    }
    if (pSectionInfo == &(Head()->data))
    {
        return lpDefault;
    }
    else
    {
        return pSectionInfo->ToString(lpKeyName, lpDefault);
    }
}




string IniFileManager::ToMultiLineString( const char* lpSectionName, const char* lpKeyName, const char* lpDefault /*= ("")*/ )
{
	PIniSectionInfo pSectionInfo = GetSection(lpSectionName);
	if (!pSectionInfo)
	{
		return lpDefault;
	}
	if (pSectionInfo == &(Head()->data))
	{
		return lpDefault;
	}
	else
	{
		return pSectionInfo->ToMultiLineString(lpKeyName, lpDefault);
	}
}

string IniFileManager::GetText()
{
    string strRet = Head()->data.GetText();
	if (!ListCount())
	{
		return strRet;
	}

	for (MoveBegin(); Current() != Head(); MoveNext())
	{
		if (strRet == "")
		{
			strRet += Current()->data.GetText();
		}
		else
		{
			strRet +=SplitStrP();
			strRet += Current()->data.GetText();
		}
	}
	return strRet;
    if (strRet == (""))
    {
        MoveBegin();
        if (Current() != Head())
        {
            strRet = Current()->data.GetText();
        }
        else
        {
            return strRet;
        }
        while (strRet == (""))
        {
            MoveNext();
            if (Current() != Head())
            {
                strRet = Current()->data.GetText();
            }
            else
            {
                return strRet;
            }
        }
		if (strRet.substr(strRet.length() - SplitStrR().length()) != SplitStrP())
		{
			strRet += SplitStrP();
		}
        for (MoveNext(); Current() != Head(); MoveNext())
        {
            strRet += SplitStrP();
            strRet += Current()->data.GetText();
        }
    }
    else
    {
        for (MoveBegin(); Current() != Head(); MoveNext())
        {
			if (strRet.substr(strRet.length() - SplitStrR().length()) != SplitStrP())
			{
				strRet += SplitStrP();
			}
            strRet += SplitStrP();
            strRet += Current()->data.GetText();
        }
    }
    return strRet;
}

string IniFileManager::GetTextEx()
{
    string strRet((""));
    MoveBegin();
    if (Current() != Head())
    {
        strRet = Current()->data.GetTextEx();
    }
    else
    {
        return strRet;
    }
    while (strRet == (""))
    {
        MoveNext();
        if (Current() != Head())
        {
            strRet = Current()->data.GetTextEx();
        }
        else
        {
            return strRet;
        }
    }
    for (MoveNext(); Current() != Head(); MoveNext())
    {
        strRet += SplitStrP();
		strRet += SplitStrP();
        strRet += Current()->data.GetTextEx();
    }
    return strRet;
}


void IniFileManager::JoinTo(IniFileManager& tarIniManager)
{
    for (MoveBegin(); Current() != Head(); MoveNext())
    {
        PIniSectionInfo pTarSection = tarIniManager.GetSection(Current()->data.SectionName().c_str(), true);
        Current()->data.JoinTo(*pTarSection);
    }
}

void IniFileManager::SetAutoSave( bool bAutoSave )
{
	if (bAutoSave == m_bAutoSave)
	{
		return;
	}
	m_bAutoSave = bAutoSave;
	if (m_bAutoSave && mstrIniFileName != (""))
	{
		SaveState();
	}
}

void IniFileManager::SaveState()
{
	mstrContentSaved = GetTextEx();
}

bool IniFileManager::DidStateChanged()
{
	if (m_bAutoSave)
	{
		return (mstrContentSaved == GetTextEx())?false:true;
	}
	else
	{
		return false;
	}
}

bool IniFileManager::DidStateChangedEx()
{
	return (mstrContentSaved == GetTextEx())?false:true;
}

inline const char* IniFileManager::SplitStrP() 
{ 
	return mstrLineSplit.c_str(); 
}

inline string& IniFileManager::SplitStrR() 
{ 
	return mstrLineSplit; 
}
