/*utf8解析行 Don't remove or modify this first line!*/
//nclude "stdafx.h"
#include "WNByteBuffer.h"
#include <memory.h>
ByteBuffer::ByteBuffer(unsigned long dwBufferSize /* = DEFAULT_BUFFER_SIZE */)
    :m_dwFlag(0)
    ,m_pBuffer(NULL)
	,m_dwBufferSize(0)
	,m_dwValidSize(0)
	,m_pPos(NULL)
{
	if (dwBufferSize)
	{
		InitBuffer(dwBufferSize);
	}
}

ByteBuffer::ByteBuffer( ByteBuffer& srcByteBuffer )
	:m_pBuffer(NULL)
	,m_dwBufferSize(0)
	,m_dwValidSize(0)
	,m_pPos(NULL)
{
	*this = srcByteBuffer;
}

ByteBuffer::ByteBuffer( void* pData, unsigned long dwSize )
	:m_pBuffer(NULL)
	,m_dwBufferSize(0)
	,m_dwValidSize(0)
	,m_pPos(NULL)
{
	ReadMemory(pData, dwSize);
}

ByteBuffer::~ByteBuffer()
{
	ReleaseBuffer();
}

bool ByteBuffer::InitBuffer(unsigned long dwBufferSize /* = DEFAULT_BUFFER_SIZE */, bool bReserveData /* = false */, bool bReservePos /* = false */)
{

    WNByteBuffer newBuffer(0);
    if (!dwBufferSize)
    {
        ReleaseBuffer();
        return true;
    }

    if (dwBufferSize)
    {
        newBuffer.m_pBuffer = new unsigned char[dwBufferSize + 2];
        memset(newBuffer.m_pBuffer, 0, dwBufferSize + 2);
        newBuffer.m_dwFlag = m_dwFlag;
        newBuffer.m_dwBufferSize = dwBufferSize;
        newBuffer.m_dwValidSize = dwBufferSize;
        newBuffer.m_pPos = newBuffer.m_pBuffer;
    }

    if (bReserveData && m_pBuffer)
    {
        memcpy(newBuffer.m_pBuffer, m_pBuffer, (dwBufferSize > m_dwBufferSize)?m_dwBufferSize:dwBufferSize);
    }

    if (bReservePos)
    {
        newBuffer.SetPos(GetPos());
        newBuffer.SetValidSize(GetValidSize());
    }

    ReleaseBuffer();

    m_dwFlag = newBuffer.m_dwFlag;
    m_pBuffer = newBuffer.m_pBuffer;
    m_dwBufferSize = newBuffer.m_dwBufferSize;
    m_dwValidSize = newBuffer.m_dwValidSize;
    m_pPos = newBuffer.m_pPos;

    newBuffer.m_pBuffer = NULL;

    return true;

}

bool ByteBuffer::ReleaseBuffer()
{
	if (m_pBuffer)
	{
		delete[] m_pBuffer;
		m_pBuffer = NULL;
		m_pPos = NULL;
		m_dwBufferSize = 0;
		m_dwValidSize = 0;
	}
	return true;
}

//bool ByteBuffer::ReadFile(FILE* pFile, unsigned long dwReadSize /* = 0 */)
//{
//	if (!pFile)
//	{
//		return FALSE;
//	}
//	if (!dwReadSize)
//	{
//		if (m_pBuffer)
//		{
//			dwReadSize = m_dwBufferSize;
//		}
//		else
//		{
//			InitBuffer(dwReadSize);
//		}
//	}
//	else if (dwReadSize != m_dwBufferSize)
//	{
//		InitBuffer(dwReadSize);
//	}
//
//	unsigned long dwReadCount =  fread(m_pBuffer, dwReadSize, 1, pFile);
//#ifndef MAC_PROGRAME
//	return (dwReadCount == dwReadSize)?true:FALSE;
//#else
//	return (dwReadCount == 1)?true:FALSE;
//#endif
//}

bool ByteBuffer::ReadMemory(const void* pSrcData, unsigned long dwReadSize /* = 0 */)
{
	if (!pSrcData)
	{
		return false;
	}
	if (!dwReadSize)
	{
		if (m_pBuffer)
		{
			dwReadSize = m_dwBufferSize;
		}
		else
		{
			InitBuffer(dwReadSize);
		}
	}
	else if (dwReadSize != m_dwBufferSize)
	{
		InitBuffer(dwReadSize);
	}
	memcpy(m_pBuffer, pSrcData, dwReadSize);
	return true;
}

unsigned long ByteBuffer::OutputWithPos(void* pTarData, unsigned long dwOutputSize /* = 0 */, const unsigned long* pdwPos /* = NULL */)
{
	if (!(m_pBuffer && m_dwBufferSize))
	{
		return 0;
	}
	if (!pTarData)
	{
		return 0;
	}
	if (!dwOutputSize)
	{
		dwOutputSize = m_dwBufferSize;
	}
	if (pdwPos)
	{
		m_pPos = m_pBuffer + *pdwPos;
	}
	if (m_pPos >= m_pBuffer + m_dwBufferSize)
	{
		return 0;
	}
	else if (m_pPos + dwOutputSize < m_pBuffer + m_dwBufferSize)
	{
		memcpy(pTarData, m_pPos, dwOutputSize);
		m_pPos += dwOutputSize;
		return dwOutputSize;
	}
	else
	{
		dwOutputSize = m_pBuffer + m_dwBufferSize - m_pPos;
		memcpy(pTarData, m_pPos, dwOutputSize);
		m_pPos += dwOutputSize;
		return dwOutputSize;
	}
}

unsigned long ByteBuffer::InputWithPos(const void* pSrcData, unsigned long dwInputSize /*= 0*/, const unsigned long* pdwPos /*= NULL */ )
{
	if (!(m_pBuffer && m_dwBufferSize))
	{
		return 0;
	}
	if (!pSrcData)
	{
		return 0;
	}
	if (!dwInputSize)
	{
		return 0;
	}
	if (pdwPos)
	{
		m_pPos = m_pBuffer + *pdwPos;
	}
	if (m_pPos >= m_pBuffer + m_dwBufferSize)
	{
		return 0;
	}
	else if (m_pPos + dwInputSize > m_pBuffer + m_dwBufferSize)
	{
		unsigned char* pOldPos = m_pPos;
		InitBuffer(m_dwBufferSize + dwInputSize, true);
		m_pPos = pOldPos;
		memcpy(m_pPos, pSrcData, dwInputSize);
		m_pPos += dwInputSize;
		return dwInputSize;
	}
	else
	{
		memcpy(m_pPos, pSrcData, dwInputSize);
		m_pPos = m_pPos + dwInputSize;
		return dwInputSize;
	}
}


ByteBuffer& ByteBuffer::operator = ( const ByteBuffer& SrcByteBuffer )
{
	if (!SrcByteBuffer.m_pBuffer)
	{
		ReleaseBuffer();
	}
	else
	{
		InitBuffer(SrcByteBuffer.m_dwBufferSize);
		memcpy(m_pBuffer, SrcByteBuffer.m_pBuffer, m_dwBufferSize);
	}
	return *this;
}

ByteBuffer& ByteBuffer::operator=( const char* strData )
{
	unsigned long dwSize = strlen(strData);
	InitBuffer(dwSize);
	memcpy(m_pBuffer, strData, dwSize);
	return *this;
}

bool ByteBuffer::operator==( const ByteBuffer& srcData )
{
	if (&srcData == this)
	{
		return true;
	}
	else if (m_dwBufferSize == srcData.m_dwBufferSize)
	{
		if (m_pBuffer && srcData.m_pBuffer)
		{
			for (unsigned long i = 0; i < m_dwBufferSize; i++)
			{
				if (m_pBuffer[i] != srcData.m_pBuffer[i])
				{
					return false;
				}
			}
			return true;
		}
		else if (!m_pBuffer && !srcData.m_pBuffer)
		{
			return true;
		}
	}
	return false;
}

bool ByteBuffer::operator==( const char* strSrc )
{
	if (!strSrc)
	{
		return false;
	}
	if (m_pBuffer)
	{
		if (!strcmp((char*)m_pBuffer, strSrc))
		{
			return true;
		}
	}
	else if (!strSrc)
	{
		return true;
	}
	return false;
}

//bool ByteBuffer::SaveFile(const char* strFilename, bool bUseValidSize /* = true */)
//{
//	FILE* pFile = fopen(strFilename, "wb");
//	if (!pFile)
//	{
//		return FALSE;
//	}
//	fwrite(m_pBuffer, bUseValidSize?m_dwValidSize:m_dwBufferSize, 1, pFile);
//	fclose(pFile);
//	return true;
//}

unsigned long ByteBuffer::SetValidString( unsigned long dwStrLen )
{
	if (dwStrLen < m_dwBufferSize)
	{
		memset(m_pBuffer + dwStrLen, m_dwBufferSize - dwStrLen, 0);
		m_dwValidSize = dwStrLen;
	}
	return m_dwValidSize;
}

unsigned long ByteBuffer::SetValidSize( unsigned long dwSize )
{
	if (dwSize < m_dwBufferSize)
	{
		m_dwValidSize = dwSize;
	}
	else
	{
		m_dwValidSize = m_dwBufferSize;
	}
	return m_dwValidSize;
}




WNByteBuffer::WNByteBuffer( unsigned long dwBufferSize /*= DEFAULT_BUFFER_SIZE*/ )
	:ByteBuffer(dwBufferSize)
	,mpBufferManager(NULL)
{

}
