/*utf8解析行 Don't remove or modify this first line!*/
#ifdef __WINOS__
#include "StdAfx.h"
#endif
#define DEFAULT_BUFFER_SIZE 0

#include "WNByteBufferManager.h"



WNByteBufferList::WNByteBufferList()
	:muBufferSize(0)
{

}


WNByteBufferManager::WNByteBufferManager(unsigned int uMinBufferSize /* = DefMinBufferSize */, unsigned int uSetpBufferSize /* = DefSetpBufferSize */, unsigned int uMaxBufferSize /* = DefMaxBufferSize */)
	:mpBufferList(NULL)
	,muListCount(0)
	,muMinBufferSize(0)
	,muStepBufferSize(0)
	,muMaxBufferSize(0)
    ,muAllBufferSize(0)
	,muMaxAllBufferSize(DefMaxAllBufferSize)
    ,muAllBufferCount(0)
    ,muMaxAllBufferCount(DefMaxBufferCount)
{
	InitManager(uMinBufferSize, uSetpBufferSize, uMaxBufferSize);
}


WNByteBufferManager::~WNByteBufferManager(void)
{
	FreeManager();
}

//进1取整宏
#define INTV(x, y) ((x + y - 1) / y)

void WNByteBufferManager::InitManager( unsigned int uMinBufferSize, unsigned int uStepBufferSize, unsigned int uMaxBufferSize )
{
	if (!uStepBufferSize)
	{
		uStepBufferSize = DefSetpBufferSize;
	}
	if (uMaxBufferSize < uMinBufferSize)
	{
		uMaxBufferSize = uMinBufferSize;
	}
	if (muListCount)
	{
        if (uMaxBufferSize != muMaxBufferSize)
		{
			FreeManager();
		}
		else if (uStepBufferSize != muStepBufferSize)
		{
			FreeManager();
		}
        else if (INTV((uMaxBufferSize - uMinBufferSize), uStepBufferSize) != INTV((muMaxBufferSize - muMinBufferSize), muStepBufferSize))
		{
			FreeManager();
		}
		else
		{
			//所有参数相同，无需重新初始化
			return;
		}
	}
	muMinBufferSize = uMinBufferSize;
	muStepBufferSize= uStepBufferSize;
	muMaxBufferSize = uMaxBufferSize;
	muListCount = INTV((muMaxBufferSize - muMinBufferSize), muStepBufferSize) + 1;

	//初始化自由缓冲区列表数组
	mpBufferList = new WNByteBufferList[muListCount + 1];

	for (unsigned int i = 1; i <= muListCount; i++)
	{
		mpBufferList[i].muBufferSize = muMinBufferSize + muStepBufferSize * (i - 1);
	}
}

void WNByteBufferManager::FreeManager()
{
	if (!muListCount)
	{
		return;
	}
	delete [] mpBufferList;
	mpBufferList = NULL;
	muListCount = 0;
	muMinBufferSize = 0;
	muStepBufferSize = 0;
	muMaxBufferSize = 0;
    muAllBufferSize = 0;
    muAllBufferCount = 0;
}

void WNByteBufferManager::InitBuffers( unsigned int uBufferSize, unsigned int uCount /*= 1*/ )
{
	if (!muListCount)
	{
		return;
	}
	WNByteBufferList* pBufferList = GetListByBufferSize(uBufferSize);
	for (unsigned int i = 0; i < uCount; i++)
	{
		WNByteBufferList::PNode pNode = new WNByteBufferList::Node;
		pNode->data.InitBuffer(pBufferList->muBufferSize);
        muAllBufferSize += pBufferList->muBufferSize?pBufferList->muBufferSize:uBufferSize;
        muAllBufferCount++;
		pBufferList->AppendNode(pNode);
	}
}

WNByteBuffer* WNByteBufferManager::GetBuffer(unsigned int uBufferSize, bool mbThreadSafeBuffer /* = FALSE */)
{
	if (!muListCount)
	{
		return NULL;
	}
	WNByteBufferList::PNode pNode = NULL;
	Lock();
	WNByteBufferList* pBufferList = GetListByBufferSize(uBufferSize);
	if (pBufferList->ListCount())
	{
		pNode = pBufferList->DetachNode(pBufferList->Begin());
        muAllBufferSize -= pNode->data.BufferSize();
        muAllBufferCount--;
		pNode->data.MovePosBegin();
		Unlock();
	}
	else
	{
		if (pBufferList->muBufferSize)
		{
			//如果缓冲区列表指定的缓冲区大小不为0，则表示在范围内
			uBufferSize = pBufferList->muBufferSize;
		}
		//Unlock();
		pNode = new WNByteBufferList::Node;
        if (!pNode)
        {
            return NULL;
        }
        pNode->data.mbIsAllocOnHeap = true;
        if (!pNode->data.InitBuffer(uBufferSize))
        {
            delete pNode;
            return NULL;
        }
		if (mbThreadSafeBuffer)
		{
			pNode->data.SetSafeLocker();
		}
        pNode->data.mpThis = pNode;
        pNode->data.mpTypeFn = getWNObjectTypeFnInstance<WNByteBufferList::Node>();
		pNode->data.mpBufferManager = this;
		pNode->data.Delegate() = this;
		pNode->data.Retain();
		Unlock();
	}
    pNode->data.DelayRelease();
    return (WNByteBuffer*)(&(pNode->data));
	//return (WNByteBuffer*)(pNode->data.DelayRelease());
}


void WNByteBufferManager::FreeBuffer( WNByteBuffer* pBuffer )
{
	if (!muListCount)
	{
		return;
	}
	Lock();
    if ((muAllBufferCount >= muMaxAllBufferCount) || (muAllBufferSize >= muMaxAllBufferSize))
    {
        WNByteBufferList::PNode pNode = (WNByteBufferList::PNode)pBuffer;
        delete pNode;
    }
    else
    {
        WNByteBufferList* pBufferList = GetListByBufferSize(pBuffer->BufferSize());
        pBufferList->AppendNode((WNByteBufferList::PNode)pBuffer);
        pBuffer->ResetRefInfo();
        muAllBufferCount++;
        muAllBufferSize += pBuffer->BufferSize();
    }
	Unlock();
}

void WNByteBufferManager::SetMaxAllBufferSize( unsigned int uSize )
{
    muMaxAllBufferSize = uSize;
	return;
}

void WNByteBufferManager::SetMaxBufferCount( unsigned int uCount )
{
    muMaxAllBufferCount = uCount;
	return;
}

WNByteBufferList* WNByteBufferManager::GetListByBufferSize( unsigned int uBufferSize )
{
	if (uBufferSize < muMinBufferSize)
	{
		uBufferSize = muMinBufferSize;
	}
	if (uBufferSize > mpBufferList[muListCount].muBufferSize)
	{
		return mpBufferList;
	}
	else
	{
		return mpBufferList + INTV((uBufferSize - muMinBufferSize), muStepBufferSize) + 1;
	}
}

bool WNByteBufferManager::OnWNObjectRetainCountIsZero( WNObject* pObject )
{
    if (!muListCount)
    {
        return true;
    }
    Lock();
    if ((muAllBufferCount >= muMaxAllBufferCount) || (muAllBufferSize >= muMaxAllBufferSize))
    {
        Unlock();
        return true;
    }
    else
    {
        WNByteBufferList::PNode pNode = NULL;
        pNode = (WNByteBufferList::PNode)(pObject->mpThis);
        WNByteBufferList* pBufferList = GetListByBufferSize(pNode->data.BufferSize());
        pBufferList->AppendNode(pNode);
        pNode->data.ResetRefInfo();
        muAllBufferCount++;
        muAllBufferSize += pNode->data.BufferSize();
        Unlock();
        return false;
    }
}
