/*utf8解析行 Don't remove or modify this first line!*/
#include "WNWorkThread.h"
#include <stdlib.h>
#include <sstream>
//#include "WNMsg.h"

using namespace std;
WNWorkThread* mpDefaultMainThread = NULL; //默认的主线程
WNWorkThread mDefaultMainThreadCreator; //用于在构造函数中创建默认的主线程
										//如果存在多个模块，使用第一个作为默认的主线程

#define NT_WNWorkThreadGetCurrentThread "NT_WNWorkThreadGetCurrentThread"

unsigned int muGetCurrentThreadNotification = 0;

class WNGetCurrentThreadNotification : public WNNotification
{
public:
	WNGetCurrentThreadNotification()
		:mpCurrentThread(NULL)
	{
        mThreadId = pthread_self();
        //得到获得当前线程的通知id
        if (!muGetCurrentThreadNotification)
        {
            muGetCurrentThreadNotification = WNNotificationCenter::DefaultCenter()->RegisterNotification(NT_WNWorkThreadGetCurrentThread);
        }

		muNotificationId = muGetCurrentThreadNotification;
	}
public:
	WNWorkThread* mpCurrentThread;
    pthread_t mThreadId;
};


WNThreadObserverInfoItem::WNThreadObserverInfoItem()
    :mpObserver(0)
    ,mpSender(0)
{

}

WNThreadObserverInfo::WNThreadObserverInfo()
    :muNotificationId(0)
    ,mpCenter(0)
{

}

WNWorkThread::WNWorkThread(void)
	:mpThreadDelegate(NULL)
	,mbExitOutThread(false)
	,mbExitInThread(false)
    ,mThreadId(0)
    ,mThreadHandle(0)
    ,muLastThreadExitCode(0)
	,mbIsThreadRunning(false)
	,mResetFlag(TRF_ResetMember)
    ,mpThreadDestroyFn(NULL)
{
    //if (this == &mDefaultMainThreadCreator)
    //{
    //    printf("enter DefaultMainThread WNWorkThread::WNWorkThread\n");
    //}
    //else
    //{
    //    printf("enter WNWorkThread::WNWorkThread\n");
    //}
	if (this == &mDefaultMainThreadCreator)
	{
		//判断是否已经存在默认的主线程
		//通过环境变量保证系统中只存在一个主线程
        ostringstream streamKey;
        streamKey << "WNMainThread_P" << getpid();

        ostringstream streamValue;
        char* pchValue = getenv(streamKey.str().c_str());

        if (!pchValue)
		{
			//创建默认的主线程
			mpDefaultMainThread = this;
			//在环境变量中写入
            streamValue << (long)mpDefaultMainThread;
            setenv(streamKey.str().c_str(),streamValue.str().c_str(),1);
            mThreadId = pthread_self();
		}
		else
		{
			//设置默认的主线程
            mpDefaultMainThread =  (WNWorkThread*)(void*)atol(streamValue.str().c_str());
		}
	}
}


WNWorkThread::~WNWorkThread(void)
{
    //if (this == &mDefaultMainThreadCreator)
    //{
    //    printf("enter DefaultMainThread WNWorkThread::~WNWorkThread\n");
    //}
    //else
    //{
    //    printf("enter WNWorkThread::~WNWorkThread\n");
    //}
	EndWork();
    ClearMessageQueue();
    //if (this == &mDefaultMainThreadCreator)
    //{
    //    printf("exit DefaultMainThread WNWorkThread::~WNWorkThread\n");
    //}
    //else
    //{
    //    printf("exit WNWorkThread::~WNWorkThread\n");
    //}
}


void WNWorkThread::Sleep(unsigned int uTimeout, unsigned uMultiplier /*= 1000*/)
{
    unsigned int uTmp = uTimeout * uMultiplier;
    if (uTmp >= 1000000)
    {
        sleep(uTmp / 1000000);
        usleep(uTmp % 1000000);
    }
    else
    {
        usleep(uTmp);
    }
}

unsigned int WNWorkThread::GetTickCount()
{
    static timeval firstTime = { 0, 0 };
    if (!firstTime.tv_sec && !firstTime.tv_usec)
    {
        gettimeofday(&firstTime,NULL);
    }
    timeval nowTime = { 0, 0 };
    gettimeofday(&nowTime, NULL);

    if (nowTime.tv_usec < firstTime.tv_usec)
    {
        return (nowTime.tv_sec - 1 - firstTime.tv_sec) * 1000 + (nowTime.tv_usec + 1000000 - firstTime.tv_usec) / 1000;
    }
    else
    {
        return (nowTime.tv_sec - firstTime.tv_sec) * 1000 + (nowTime.tv_usec - firstTime.tv_usec) / 1000;
    }
}

void WNWorkThread::DoEvents(WNWorkThread *pThread /*= NULL*/)
{
    if (!pThread)
    {
        pThread = WNWorkThread::GetCurrentThread();
    }
    if (!pThread)
    {
        return;
    }
    while (pThread->ProcessMessageInQueue())
    {

    }
}

void WNWorkThread::DoEvents(unsigned int uTimeOut , WNWorkThread *pThread /*= NULL*/)
{
    unsigned int uStartTime = WNWorkThread::GetTickCount();
    if (!pThread)
    {
        pThread = WNWorkThread::GetCurrentThread();
    }
    if (!pThread)
    {
        return;
    }
    while (true)
	{
        while (pThread->ProcessMessageInQueue())
		{
		}
        if (WNWorkThread::GetTickCount() - uStartTime >= uTimeOut)
		{
			break;
		}
	}
}

void WNWorkThread::DoEventsAndSleep(unsigned int uSleepTime, WNWorkThread *pThread /*= NULL*/)
{
    if (!pThread)
    {
        pThread = WNWorkThread::GetCurrentThread();
    }
    if (!pThread)
    {
        return;
    }
    while (pThread->ProcessMessageInQueue())
	{
	}
	if (uSleepTime)
	{
        WNWorkThread::Sleep(uSleepTime);
	}
}

void WNWorkThread::DoEventsAndSleep( unsigned int uTimeOut, unsigned int uSleepTime, WNWorkThread *pThread /*= NULL*/ )
{
    unsigned int uStartTime = WNWorkThread::GetTickCount();
    if (!pThread)
    {
        pThread = WNWorkThread::GetCurrentThread();
    }
    if (!pThread)
    {
        return;
    }
    while (true)
	{
        while (pThread->ProcessMessageInQueue())
		{
		}
        if (WNWorkThread::GetTickCount() - uStartTime >= uTimeOut)
		{
			break;
		}
		else if (uSleepTime)
		{
            WNWorkThread::Sleep(uSleepTime);
		}
	}
}

void* WNWorkThread::InternalThreadMain( void* lpParam )
{
    unsigned int dwRet = 0;

    WNWorkThread* pThread = (WNWorkThread*)lpParam;

    pThread->StartObserveNotification(NT_WNWorkThreadGetCurrentThread);
    pThread->mbIsThreadRunning = true;
    pThread->ClearMessageQueue();
    if (pThread->mpThreadDelegate)
    {
        if (pThread->mpThreadDelegate->OnWorkThreadStart(pThread) == WN_WORK_THREAD_EXIT)
        {
            goto WNWorkThread_InternalThreadMain_Exit;
        }
    }

    dwRet = pThread->ThreadMain();
    pThread->ClearMessageQueue();
WNWorkThread_InternalThreadMain_Exit:
    bool bExitInThread = false;
    ThreadResetFlag trfFlag = TRF_ResetMember;

    bExitInThread =  pThread->mbExitInThread;

    if (pThread->mpThreadDelegate)
    {
        dwRet = pThread->mpThreadDelegate->OnWorkThreadProcEnd(pThread);
    }
    pThread->muLastThreadExitCode = dwRet;
    trfFlag = pThread->mResetFlag;
    pThread->DoReset();
    pThread->StopObserveNotification(NT_WNWorkThreadGetCurrentThread);

    bool bIsMainThread = pThread->IsMainThread();

    if (trfFlag == TRF_DeleteInstance)
    {
        while (pThread->mbExitOutThread)
        {
            WNWorkThread::Sleep(1);
        }
        pThread->mbExitOutThread = false;
        pThread->mbExitInThread = false;
        WNWorkThread::WNThreadDestroyFn pDestroyFn = pThread->mpThreadDestroyFn;
        if (pDestroyFn)
        {
            pDestroyFn(pThread);
        }
        else
        {
            delete pThread;
        }
        pThread = 0;
    }
    else
    {
        pThread->mbExitOutThread = false;
        pThread->mbExitInThread = false;
    }

    if (!bIsMainThread)
    {
        DoExitThread(dwRet);
    }

    return (void*)(unsigned int*)dwRet;
}

void WNWorkThread::StartWork()
{
	if (IsThreadRunning())
	{
		return;
	}
    if (IsMainThread())
	{
		//在主线程中调用
        WNWorkThread::InternalThreadMain(this);
	}
    else
    {
        CreateThread();
    }
}

void WNWorkThread::EndWork(unsigned int dwTimeOut /* = 500 */)
{
    if (!IsThreadRunning())
    {
        return;
    }

    if (IsCurrentThread())
	{
		//EndWork函数在线程内被调用
        mbExitInThread = true;
		return;
	}
	else
	{
		//EndWork函数在线程外被调用
        void* hThreadHandle = 0;
		mbExitOutThread = true;
		hThreadHandle = mThreadHandle;
		while (!WaitThreadEnd(dwTimeOut))
		{
			//等待直到线程函数正常结束
		}
        mbExitOutThread = false;
//		//由于线程函数结束后线程无法正常退出
//		//因此使用系统调用判断线程是否正常退出
//		//此过程只在线程外关闭线程时使用
//		DWORD dwExitCode = 0;
//		DWORD dwThreadExitTime = 0;
//		while (::GetExitCodeThread(hThreadHandle, &dwExitCode))
//		{
//			if (dwExitCode == STILL_ACTIVE)
//			{
//				::Sleep(1);
//				if (!dwThreadExitTime)
//				{
//					dwThreadExitTime = ::GetTickCount();
//				}
//				if (::GetTickCount() - dwThreadExitTime >= dwTimeOut)
//				{
//					//强制退出线程
//					WNWorkThread::DoTerminateThread(hThreadHandle, 0);
//					break;
//				}
//			}
//			else
//			{
//				break;
//			}
//		}
	}
}

bool WNWorkThread::CreateThread()
{
    pthread_t idThread;
    int err = pthread_create(&idThread, NULL, &WNWorkThread::InternalThreadMain, this);
    if ( 0 != err )
    {
        printf("can't create ntid_joinable thread:%s\n", strerror(err));
        return false;
    }
    mThreadHandle = this;
    mThreadId = idThread;
    return true;
}

unsigned int WNWorkThread::ThreadMain()
{
    unsigned int dwStep = 0;
    unsigned int uSleepTime = 0;
    while (!mbExitOutThread && !mbExitInThread)
    {
        if (mpThreadDelegate)
        {
            if (WN_WORK_THREAD_EXIT == mpThreadDelegate->OnWorkThreadProc(this, dwStep))
            {
                mbExitInThread = true;
            }
            while (true)
            {
                if (!ProcessMessageInQueue())
                {
                    uSleepTime = mpThreadDelegate->OnWorkThreadNeedSleep(this);
                    if (uSleepTime)
                    {
                        WNWorkThread::Sleep(uSleepTime);
                    }
                    break;
                }
            }
        }
        else
        {
            if (WN_WORK_THREAD_EXIT == ThreadProc(dwStep))
            {
                mbExitInThread = true;
            }
        }
        //DoCheckAndInvoke();
    }
	return 0;
}

bool WNWorkThread::ThreadProc(unsigned int uStep )
{
	DoEventsAndSleep(1);
	return true;
}

bool WNWorkThread::IsMainThread()
{
    return (this == mpDefaultMainThread)?true:false;
}

bool WNWorkThread::IsThreadRunning()
{
    return mbIsThreadRunning?((mThreadHandle && mThreadId)?true:false):false;
}

bool WNWorkThread::IsCurrentThread()
{
    if (IsThreadRunning())
    {
        pthread_t idThread = pthread_self();
        return pthread_equal(idThread, mThreadId)?true:false;
    }
    else
    {
        return false;
    }
}

WNWorkThread* WNWorkThread::GetCurrentThread()
{
	WNGetCurrentThreadNotification notification;
	notification.muNotificationId = muGetCurrentThreadNotification;
	WNNotificationCenter::DefaultCenter()->PostNotification(&notification);
	return notification.mpCurrentThread;
}

WNWorkThread* WNWorkThread::GetMainThread()
{
	return mpDefaultMainThread;
}



unsigned int WNWorkThread::AddObserve4Notification(WNNotificationObserver* pObserver, const char* lpNotificationName, void* pSender /*= NULL*/, WNNotificationCenter* pNotificationCenter /*= NULL*/)
{
    if (!pNotificationCenter)
    {
        pNotificationCenter = WNNotificationCenter::DefaultCenter();
    }
    mObserverListLocker.Lock();
    //由线程本身去注册接收消息
    unsigned int uNotificationId = StartObserveNotification(lpNotificationName, 0, pNotificationCenter);
    WNThreadObserverInfo* pInfo = NULL;
    for (mObserverInfoList.MoveBegin(); mObserverInfoList.NotHead(); mObserverInfoList.MoveNext())
    {
        pInfo = &(mObserverInfoList.CurrentData());
        if ((pInfo->mpCenter == pNotificationCenter) && (pInfo->muNotificationId == uNotificationId))
        {
            //已找到对应的消息中心以及消息
            break;
        }
        else
        {
            pInfo = NULL;
        }
    }
    if (!pInfo)
    {
        //未找到对应的消息中心以及消息
        //添加对应消息中心以及消息
        WNThreadObserverInfoList::PNode pNode = new WNThreadObserverInfoList::Node;
        pNode->data.mpCenter = pNotificationCenter;
        pNode->data.muNotificationId = uNotificationId;
        pInfo = &(pNode->data);
        mObserverInfoList.AppendNode(pNode);
    }
    //在pInfo中查找是否pObserver已存在
    WNThreadObserverInfoItem* pInfoItem = NULL;
    for (pInfo->mObserverList.MoveBegin();pInfo->mObserverList.NotHead();pInfo->mObserverList.MoveNext())
    {
         pInfoItem = &(pInfo->mObserverList.CurrentData());
        if (pInfoItem->mpObserver == pObserver)
        {
            //已找到对应的观察者
            break;
        }
        else
        {
            pInfoItem = NULL;
        }
    }
    if (!pInfoItem)
    {
        //未找到对应的观察者
        //添加对应的观察者
        WNThreadObserverInfoItemList::PNode pNode = new WNThreadObserverInfoItemList::Node;
        pInfoItem = &(pNode->data);
        pInfo->mObserverList.AppendNode(pNode);
    }
    //设置观察者
    pInfoItem->mpObserver = pObserver;
    //设置发送者
    pInfoItem->mpSender = pSender;
    mObserverListLocker.Unlock();
    return uNotificationId;
}

void WNWorkThread::RemoveObserve4Notification(WNNotificationObserver* pObserver, const char* lpNotificationName /*= NULL*/, void* pSender /*= NULL*/, WNNotificationCenter* pNotificationCenter /*= NULL*/)
{
    if (!pNotificationCenter)
    {
        pNotificationCenter = WNNotificationCenter::DefaultCenter();
    }
    if (lpNotificationName)
    {
        //指定了消息名称
        unsigned int uNotificationId = pNotificationCenter->GetNotificationIdByName(lpNotificationName);
        if (!uNotificationId)
        {
            //没有对应消息，直接返回
            return;
        }
        mObserverListLocker.Lock();
        WNThreadObserverInfo* pInfo = NULL;
        for (mObserverInfoList.MoveBegin(); mObserverInfoList.NotHead(); mObserverInfoList.MoveNext())
        {
            pInfo = &(mObserverInfoList.CurrentData());
            if ((pInfo->mpCenter == pNotificationCenter) && (pInfo->muNotificationId == uNotificationId))
            {
                //已找到对应的消息中心以及消息
                break;
            }
            else
            {
                pInfo = NULL;
            }
        }
        if (!pInfo)
        {
            //未找到对应的消息中心以及消息
            //直接返回
            mObserverListLocker.Unlock();
            return;
        }
        //已找到对应的消息中心以及消息pInfo
        //从pInfo中移除与pObserver以及pSender相符合的项
        WNThreadObserverInfoItem* pInfoItem = NULL;
        WNThreadObserverInfoItemList::PNode pNode = NULL;
        for (pNode = pInfo->mObserverList.Begin(); pNode != pInfo->mObserverList.Head();)
        {
            pInfoItem = &(pNode->data);
            pNode = pNode->nextNode;
            if ((pInfoItem->mpObserver == pObserver) && (pInfoItem->mpSender == pSender))
            {
                //找到相符合的项
                pInfo->mObserverList.RemoveNode(pNode->prevNode);
            }
        }
        if (!pInfo->mObserverList.ListCount())
        {
            //没有需要转发的消息
            //停止监听pInfo所对应的消息
            StopObserveNotification(pInfo->mpCenter->GetNotificationNameById(pInfo->muNotificationId), 0, pInfo->mpCenter);
            //移除节点
            mObserverInfoList.RemoveNode((WNThreadObserverInfoList::PNode)pInfo);
        }
        mObserverListLocker.Unlock();
    }
    else
    {
        //未指定消息名称
        mObserverListLocker.Lock();
        WNThreadObserverInfo* pInfo = NULL;
        WNThreadObserverInfoList::PNode pInfoNode = NULL;
        WNThreadObserverInfoItem* pInfoItem = NULL;
        WNThreadObserverInfoItemList::PNode pItemNode = NULL;
        //遍历消息转发映射表
        for (pInfoNode = mObserverInfoList.Begin(); pInfoNode != mObserverInfoList.Head();)
        {
            pInfoNode = pInfoNode->nextNode;
            pInfo = &(mObserverInfoList.CurrentData());
            //遍历每个消息的项列表
            for (pItemNode = pInfo->mObserverList.Begin(); pItemNode != pInfo->mObserverList.Head();)
            {
                pInfoItem = &(pItemNode->data);
                pItemNode = pItemNode->nextNode;
                if ((pInfoItem->mpObserver == pObserver) && (pInfoItem->mpSender == pSender))
                {
                    //移除项
                    pInfo->mObserverList.RemoveNode(pItemNode->prevNode);
                }
            }
            if (!pInfo->mObserverList.ListCount())
            {
                //没有需要转发的消息
                //停止监听pInfo所对应的消息
                StopObserveNotification(pInfo->mpCenter->GetNotificationNameById(pInfo->muNotificationId), 0, pInfo->mpCenter);
                //移除节点
                mObserverInfoList.RemoveNode(pInfoNode->prevNode);
            }
        }
        mObserverListLocker.Unlock();
    }
}


bool WNWorkThread::PostThreadMessage(WNNotification *pNotification)
{
    mMsgQueueLocker.Lock();
    if (!IsThreadRunning())
    {
        mMsgQueueLocker.Unlock();
        return false;
    }
    WNNotification* pMsg = NULL;
    if (pNotification->mbIsAllocOnHeap)
    {
        //堆上分配的内存，直接Retain
        pMsg = (WNNotification*)pNotification->Retain();
    }
    else
    {
        //栈上分配的内存，需要拷贝
        pMsg = WNSafeAlloc(WNNotification);
        pMsg->muNotificationId = pNotification->muNotificationId;
        pMsg->mpNotificationSender = pNotification->mpNotificationSender;
        if (pNotification->mpNotificationData)
        {
            pMsg->mpNotificationData = pNotification->Retain();
        }
        pMsg->mpNotificationCenter = pNotification->mpNotificationCenter;
        for (unsigned int i = 0; i < pMsg->muParamsCount; i++)
        {
            pMsg->mParams[i] = pNotification->mParams[i];
        }
        pMsg->Retain();
    }
    WNCLoopList<WNNotification*>::PNode pNode = new WNCLoopList<WNNotification*>::Node;
    pNode->data = pMsg;
    mMsgQueue.AppendNode(pNode);
    mMsgQueueLocker.Unlock();
    return true;
}

bool WNWorkThread::ProcessMessageInQueue()
{
    if (!mMsgQueue.ListCount())
    {
        return false;
    }    
    if (!IsThreadRunning())
    {
        return false;
    }
    mMsgQueueLocker.Lock();
    WNCLoopList<WNNotification*>::PNode pDetachedNode = NULL;
    pDetachedNode = mMsgQueue.DetachNode(mMsgQueue.Begin());
    WNNotification* pNotification = pDetachedNode->data;
    WNThreadObserverInfo* pObserverInfo = NULL;
    WNThreadObserverInfoItem* pObserverInfoItem = NULL;
    mMsgQueueLocker.Unlock();
    mObserverListLocker.Lock();
    for (mObserverInfoList.MoveBegin(); mObserverInfoList.NotHead(); mObserverInfoList.MoveNext())
    {
        pObserverInfo = &(mObserverInfoList.CurrentData());
        if ((pNotification->muNotificationId == pObserverInfo->muNotificationId)
                && (pNotification->mpNotificationCenter == pObserverInfo->mpCenter))
        {
            for (pObserverInfo->mObserverList.MoveBegin(); pObserverInfo->mObserverList.NotHead(); pObserverInfo->mObserverList.MoveNext())
            {
                pObserverInfoItem = &(pObserverInfo->mObserverList.CurrentData());
                if (pNotification->mpNotificationSender == pObserverInfoItem->mpSender)
                {
                    pObserverInfoItem->mpObserver->OnReceiveNotification(pNotification, this);
                }
            }
            break;
        }
    }
    doRelease(pDetachedNode->data->mpNotificationData);
    doRelease(pDetachedNode->data);
    delete pDetachedNode;
    mObserverListLocker.Unlock();
    return true;
}

void WNWorkThread::ClearMessageQueue()
{
    mMsgQueueLocker.Lock();
    if (!mMsgQueue.ListCount())
    {
        mMsgQueueLocker.Unlock();
        return;
    }
    WNCLoopList<WNNotification*>::PNode pNode = NULL;
    WNCLoopList<WNNotification*>::PNode pDetachedNode = NULL;

    for (pNode = mMsgQueue.Begin(); pNode != mMsgQueue.Head();)
    {
        pNode = pNode->nextNode;
        pDetachedNode = mMsgQueue.DetachNode(pNode->prevNode);
        doRelease(pDetachedNode->data);
        delete pDetachedNode;
    }
    mMsgQueueLocker.Unlock();
}

void WNWorkThread::OnReceiveNotification( WNNotification* pNotification )
{
    if (!IsThreadRunning())
	{
		return;
	}
	if (pNotification->muNotificationId == muGetCurrentThreadNotification)
	{
		WNGetCurrentThreadNotification* pNotificationData = (WNGetCurrentThreadNotification*)pNotification;
        if (pNotificationData->mThreadId == mThreadId)
		{
			pNotificationData->mpCurrentThread = this;
		}
	}
    else
    {
        PostThreadMessage(pNotification);
    }
}

void WNWorkThread::DoReset()
{
    if (mThreadId)
	{
        mThreadId = 0;
	}
	if (mThreadHandle)
	{
		mThreadHandle = 0;
	}
	mbIsThreadRunning = false;
}

bool WNWorkThread::WaitThreadEnd( unsigned int dwTimeOut /*= 500*/ )
{
    unsigned int dwStartTime = WNWorkThread::GetTickCount();
    while (IsThreadRunning())
	{
        if (WNWorkThread::GetTickCount() - dwStartTime > dwTimeOut)
		{
			return false;
		}
		else
		{
            WNWorkThread::Sleep(1);
		}
	}
	return true;
}

bool WNWorkThread::DoTerminateThread( WNThreadId hThreadHandle, unsigned int uExitCode /*= 0 */ )
{
//	if (hThreadHandle)
//	{
//		return ::TerminateThread(hThreadHandle, uExitCode)?true:false;
//	}
//	else
//	{
//		return true;
//	}
    return false;
}

void WNWorkThread::DoExitThread( unsigned int uExitCode /*= 0*/ )
{
    pthread_detach(pthread_self());
    pthread_exit(NULL);
//	::ExitThread(uExitCode);
}
