#ifndef _DT_TTSMANAGER_H_
#define _DT_TTSMANAGER_H_

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "PcmPlayer.h"

#include <hash_map>
using namespace std;

struct NumData
{
	int iLen;
	char * pData;
};

class TTSManager{
public:
	TTSManager();
	~TTSManager();
	
	bool InitSoundMap();
	void UninitSoundMap();
	
	int CreateNumberData(int intPart, const char * decPart, char * pBuf);
	
	int PlayWelcome();
	
	int PlayNoInfoAtStart();
	int PlayNoInfoAtThisPoint();
	int PlayRankingInfo(int level, int timeIntPart, const char * timeDecPart);
	
	int PlayNoUserInfo();
	int PlayUserInfo(int * intPart, char * decPart[]);//为四组，分别表示个人运动信息中的四个可能带小数的数字
	
	int PlaySetStart();
	int PlayUserDistance(int intPart, const char * decPart);
	
	int PlayNoMatchThisCard();
	
	int Reset();
private:
	bool ReadPcmFile(int num);
	int CopyPcmBuf(int num, char * pBuf);
	
	int CheckNumber(int & num, int mul, int pre = 0);
	
	int PlaySoundById(int soundid);
	
	char * m_pNumBuf;
	hash_map<int, NumData*> m_numMap;
	
	PcmPlayer m_player;
};

#endif //